/**********************************************************************           
    * sdf_moc.hpp -- The synchronous dataflow model of computation    *
    *                                                                 *
    * Author:  Hosein Attarzadeh (shan2@kth.se)                       *
    *                                                                 *
    * Purpose: Providing promitive element required for modeling      *
    *          synchronous dataflow systems in ForSyDe-SystemC        *
    *                                                                 *
    * Usage:   This file is included automatically                    *
    *                                                                 *
    * License: BSD3                                                   *
    *******************************************************************/

#ifndef SDF_MOC_HPP
#define SDF_MOC_HPP

/*! \file sdf_moc.hpp
 * \brief Implements the Synchronous Dataflow (SDF) Model of Computation
 * 
 *  This file includes the basic process constructors and other
 * facilities used for modeling in the SDF model of computation.
 */

#include <functional>
#include <tuple>

#include "sdf_process.hpp"
#include "sdf_process_constructors.hpp"
#include "sdf_helpers.hpp"

namespace ForSyDe
{

//! The namespace for synchronous dataflow MoC
/*! This namespace includes constructs used for building models in the
 * synchronous dataflow MoC.
 */
namespace SDF
{


}
}

#endif
