/**********************************************************************           
    * ut_moc.hpp -- The untimed model of computation                  *
    *                                                                 *
    * Author:  Hosein Attarzadeh (shan2@kth.se)                       *
    *                                                                 *
    * Purpose: Providing promitive element required for modeling      *
    *          synchronous dataflow systems in ForSyDe-SystemC        *
    *                                                                 *
    * Usage:   This file is included automatically                    *
    *                                                                 *
    * License: BSD3                                                   *
    *******************************************************************/

#ifndef UT_MOC_HPP
#define UT_MOC_HPP

/*! \file ut_moc.hpp
 * \brief Implements the Untimed (UT) Model of Computation
 * 
 *  This file includes the basic process constructors and other
 * facilities used for modeling in the untimed model of computation.
 */

#include <functional>
#include <tuple>

#include "ut_process.hpp"
#include "ut_process_constructors.hpp"
#include "ut_helpers.hpp"

namespace ForSyDe
{

//! The namespace for untimed MoC
/*! This namespace includes constructs used for building models in the
 * synchronous dataflow MoC.
 */
namespace UT
{


}
}

#endif
